# libtorrent.i, libtorrent.h

libtorrent.i contains SWIG extensions, ignores, and directives needed to wrap the libtorrent library.
It includes `libtorrent.h` where other C++ functions are defined manually.

# run-swig.sh

Whenever you make changes to libtorrent.i and you need SWIG to re-write java classes in the parent java folders you must run this file manually.

It's not invoked by any of the build-scripts. The build-scripts assume the autogenerated java code by SWIG is already there.

# build-utils.shinc, build-macos.sh, build-linux-x86_64.sh, build-android-arm.sh, build-andriod-arm64.sh, build-android-x86.sh, build-android-x86_64.sh

These are scripts meant to be run on your local machine so that you can debug and test any changes you may have done.

Otherwise you'll have to push your local changes to your repository, which should be configured with Travis-CI, and AWS S3 to have travis remotely build your latest changes.

This is a very slow process, therefore we have these build scripts which are meant to be identical to ../travis.yml

# package-remote-build.sh

This script downloads the latest .so, .dlls and .dylib files from https://s3.amazonaws.com/gubatron-jlibtorrent/release/<os_build>/<os_arch>/<library>, places them inside the swig/bin/release/<os_build>/<os_arch> and then invokes the parent folder's `gradle build` command to generate all the release .jars we distribute at
https://github.com/frostwire/frostwire-jlibtorrent/releases
